/*
Daybo Logic Utilities Library
Copyright (C) 2000-2005 Daybo Logic.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. Neither the name of the project nor the names of its contributors
   may be used to endorse or promote products derived from this software
   without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

This completely ANSI C (1990) portable library set is a set of
utilities that may be used by Daybo Logic and ther selected
parties given permission to use, modify and work on add-ins for
the library.  The main header itself should only be worked on
by David Duncan Ross Palmer for management reasons.  Add-in
modules should be written by David Duncan Ross Palmer, members
of Daybo Logic or any other selected individuals or alies.
Their headers can then be included ultimately in this module
providing other library or program programmers with one header
to include the enture library.  Any add-in modules should know
that they may be included in a static or dynamic link library
at some stage.

Written by David Duncan Ross Palmer 11th April 1999
*/

/* Revision: --->("3")<--- */

#ifndef INC_DLUTILS_DLUTILS_H
#define INC_DLUTILS_DLUTILS_H
/*-------------------------------------------------------------------------*/
/* Version information */
#define DLUTILS_VER_MAJOR (0)
#define DLUTILS_VER_MINOR (1)
#define DLUTILS_VER_BUILD (0)

typedef struct S_DLUTILS_FILE_BLOCK_SIZE {
  unsigned long BufferSize;
  unsigned long Loops;
  unsigned long Remainder;
} DLUTILS_FILE_BLOCK_SIZE;

/*
  Support for "out of memory" messages and automatic program failure
  in case of allocation failure, so programmers don't have to bother
  with NULL returns from malloc() etc.
*/
#include "dlutils_sdynmem.h"

/*
  DLUtils' fatal trap support has temporarily been disabled and is
  due for a revamp.  If you find legacy code which uses it, let me
  know and I'll hack something up
*/
/*#include "fatltrap.h"*/

BOOL dlutils_Version(
  struct _S_DL_MODVER *PModVer
);

BOOL dlutils_VersionEx(
  struct _S_DL_MODVER_EX *PModVer
);

int dlutils_GetFileLength(
  FILE *HFile,
  unsigned long *PLength
);

int dlutils_CalcFileBlockSize(
  unsigned long FileLength,
  DLUTILS_FILE_BLOCK_SIZE *CallerFileBlockSizePtr,
  const size_t BufferSize
);

WORD utils_RevWORD(
  const WORD W
);

DWORD utils_RevDWORD(
  const DWORD DW
);

WORD dlutils_CalcChk16(
  const void *RawData,
  const size_t SizeOfData
);

DWORD dlutils_CalcChk32(
  const void *RawData,
  const size_t SizeOfData
);

int dlutils_stricmp(
  const char *s1,
  const char *s2
);

char *dlutils_strlwr(
  char *s
);

char *utils_strupr(
  char *s
);

DWORD dlutils_CalcFileChecksum32(
  FILE *HFile
);

char *dlutils_strdup(
  const char *source
);
/*-------------------------------------------------------------------------*/
#endif /*!INC_DLUTILS_DLUTILS_H*/
