/*
Daybo Logic Utilities Library
Copyright (C) 2000-2005 Daybo Logic.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. Neither the name of the project nor the names of its contributors
   may be used to endorse or promote products derived from this software
   without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
*/


/*
  Byte swapper (processor portability aid)
  Author: David Duncan Ross Palmer
  Company: Daybo Logic
  Library: Utilities
  Language compliance: ANSI C (1990)
  Last modified - 20050907
*/
#include <stddef.h>
#include <stdio.h>
#ifdef HDRSTOP
# pragma hdrstop
#endif /*HDRSTOP*/
#include "dlstdinc.h"
#include "dlutils.h"
/*-------------------------------------------------------------------------*/
WORD utils_RevWORD(const WORD W)
{
  return MAKEWORD(HIBYTE(W), LOWORD(W)); /* Reverse word and return */
}
/*-------------------------------------------------------------------------*/
DWORD utils_RevDWORD(const DWORD DW)
{
  WORD DWH = HIWORD(DW);
  WORD DWL = LOWORD(DW);
  DWH = utils_RevWORD(DWH); /* Reverse BYTEs in high WORD */
  DWL = utils_RevWORD(DWL); /* Reverse BYTEs in low WORD */
  return MAKEDW(DWH, DWL); /* Make DWORD from WORDs backtofront */
}
/*-------------------------------------------------------------------------*/
