/*
Daybo Logic Utilities Library
Copyright (C) 2000-2005 Daybo Logic.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. Neither the name of the project nor the names of its contributors
   may be used to endorse or promote products derived from this software
   without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.


Replacement for stricmp() because that is non-ANSI

Author: David Duncan Ross Palmer
Company: Daybo Logic
Library: Utilities
Language compliance: ANSI C (1990)

Last modified 20001227

20001227: Rewrote, it used to copy, make lowercase then compare,
now I do the loop myself with tolower(), this involves no malloc()s so
is safer incase of lack of memory.  It's probally a lot faster too.
*/

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#ifdef HDRSTOP
# pragma hdrstop
#endif /*HDRSTOP*/

#include "dlstdinc.h"
#include "dlutils.h"
/*-------------------------------------------------------------------------*/
int dlutils_stricmp(
  const char *s1,
  const char *s2
)
{
  size_t i = (size_t)0U;
  int ret = 0;

  if ( !s1 || !s2 ) return -1; /* Safety */

  while ( s1[i] != '\0' && s2[i] != '\0' ) {
    /* Make lowercase */
    char c1 = isalpha(s1[i]) ? (tolower(s1[i])) : (s1[i]);
    char c2 = isalpha(s2[i]) ? (tolower(s2[i])) : (s2[i]);

    ret += ( c1 - c2 ); /* Change mismatch (0 effect if no difference) */
    i++; /* For next loop */
  }
  return ret;
}
/*-------------------------------------------------------------------------*/
